# dts-from-thrift

[![npm version](https://badge.fury.io/js/dts-from-thrift.svg)](https://www.npmjs.com/package/dts-from-thrift)
[![build](https://travis-ci.org/LPegasus/dts-from-thrift.svg?branch=master)](https://travis-ci.org/LPegasus/dts-from-thrift)
[![coverage](https://img.shields.io/codecov/c/github/LPegasus/dts-from-thrift.svg?style=flat-square)](https://codecov.io/gh/LPegasus/dts-from-thrift)

thrift RPC 定义文件转 d.ts 工具

__安装(install)：__ `npm install dts-from-thrift -g`

__运行(exec)：__`dts-from-thrift -p ~/git/my-thrift-repo/thrift -o ~/git/my-ts-repo/typings`

由于实现全靠正则，特殊 case 无法避免，可以提 issue 或者 PR。

(The tool use RegExp to generate d.ts file. If some special statement cases causes bugs, an issue or a PR is welcome.)



## 变更历史（changlogs):

- **0.5.0**

  1. feat: 新增 dts-from-protobuf 支持

     (add dts-from-protobuf CLI, support protobuf)

     `dts-from-protobuf -p <protobuf_idl_dir> -o <output_dir>`

- __0.4.0__

  1. feat: 新增 --use-tag CLI option，来支持下面的语法

     (add a new option [--use-tag] to replace original fieldname with tagname)

     ```csharp
     struct Foo {
       1: list<string> comments (go.tag="json:\\"list,omitempty\\""),
     }
     
     // before 0.4.0
     interface Foo {
       comments: string[];
     }
     
     // after 0.4.0 with [--use-tag go]
     interface Foo {
       list: string[];
     }
     // detail in parseStruct.test.ts
     ```

  2. codestyle: 生成文件增加 `// prettier-ignore` 避免 format 导致的 git 提交

     (add `// prettier-ignore` at head of d.ts file to prevent useless git commit)